"use strict";
/**
 * Functional-programming utilities
 */
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
// prop :: string -> any
exports.prop = function (property) { return function (obj) {
    return obj[property];
}; };
// safeProp :: string -> any (truthy)
exports.safeProp = function (property) { return function (obj) {
    return obj[property] || {};
}; };
// asProp :: string -> any -> { string: any }
exports.asProp = function (property) { return function (value) {
    var _a;
    return (_a = {},
        _a[property] = value,
        _a);
}; };
// id :: any -> any
exports.id = function (x) {
    return x;
};
// map :: (any -> any) -> any -> any
exports.map = function (f) { return function (box) {
    return box.map(f);
}; };
// filter :: (any -> boolean) -> any -> any[]
exports.filter = function (predicate) { return function (box) {
    return box.filter(predicate);
}; };
exports.objectMap = function (f) { return function (obj) {
    return Object.keys(obj)
        .reduce(function (accumulator, key) {
        var _a;
        return Object.assign(accumulator, (_a = {}, _a[key] = f(obj[key], key), _a));
    }, {});
}; };
// trace :: string -> any -> any
exports.trace = function (label) { return function (x) {
    console.log(label + ": " + JSON.stringify(x, null, 4));
    return x;
}; };
// traceDebugger :: (string -> any) -> string -> any -> any
exports.traceDebugger = function (debugStream) { return function (label) { return function (x) {
    debugStream(label + ": " + JSON.stringify(x, null, 4));
    return x;
}; }; };
exports.log = function (isDryRun) { return function (logger) { return function () {
    var message = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        message[_i] = arguments[_i];
    }
    isDryRun ? (logger.apply(void 0, __spread(message)), exports.id) : exports.id;
}; }; };
// eslint-disable-next-line @typescript-eslint/unbound-method
Array.prototype.scan = function (callback, initialValue) {
    var appendAggregate = function (acc, item) {
        var aggregate = acc.slice(-1)[0]; //get last item
        var newAggregate = callback(aggregate, item);
        return __spread(acc, [newAggregate]);
    };
    var accumulator = [initialValue];
    return this.reduce(appendAggregate, accumulator);
};
// eslint-disable-next-line @typescript-eslint/unbound-method
Array.prototype.mash = function (callback) {
    var addKeyValuePair = function (acc, item) {
        var _a;
        var _b = __read(callback ? callback(item) : item, 2), key = _b[0], value = _b[1];
        return __assign({}, acc, (_a = {}, _a[key] = value, _a));
    };
    return this.reduce(addKeyValuePair, Object.create({}));
};
